/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.fmap.dal.feature.impl.undo.command;

import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.fmap.dal.feature.impl.FeatureTypeManager;
import org.gvsig.tools.undo.RedoException;
import org.gvsig.tools.undo.UndoException;


/**
 * DOCUMENT ME!
 *
 * @author Vicente Caballero Navarro
 */
public class FTypeUpdateCommand extends AbstractFTypeCommand {
    private FeatureType oldType;
    private int position=-1;

    public FTypeUpdateCommand(FeatureTypeManager expansionManager,
        FeatureType type, FeatureType oldType, String description) {
        super(expansionManager, type, description);
        this.oldType = oldType;
    }

    /* (non-Javadoc)
    * @see org.gvsig.fmap.dal.commands.Command#undo()
    */
    public void undo() throws UndoException {
//        if (expansionManager.contains(oldFeature.getReference())) {
//            expansionManager.deleteLastFeature(feature.getReference());
//        } else {
//            expansionManager.delete(type.getId());
//        }

        expansionManager.restore(oldType.getId(),position);
    }

    /* (non-Javadoc)
     * @see org.gvsig.fmap.dal.commands.Command#redo()
     */
    public void redo() throws RedoException {
        execute();
    }

    public int getType() {
        return UPDATE;
    }

    /* (non-Javadoc)
     * @see org.gvsig.fmap.dal.commands.Command#execute()
     */
    public void execute() {
        //		 Si la geometra no ha sido modificada
//        if (!expansionManager.contains(oldType.getId())) {
//        if (expansionManager.delete(oldType.getId())!=null){
//            expansionManager.add(type);
//        } else {
          position =  expansionManager.update(type, oldType);
//        }
    }

	public FeatureType getOldFeatureType() {
		return oldType;
	}
}
