/* gvSIG. Desktop Geographic Information System.
 *
 * Copyright  2007-2014 gvSIG Association
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.fmap.dal.swing.impl;

import org.gvsig.featureform.swing.CreateJFeatureFormException;
import org.gvsig.featureform.swing.FeatureFormDefinitionsProvider;

import org.gvsig.featureform.swing.JFeatureForm;
import org.gvsig.featureform.swing.impl.DefaultJFeatureForm;
import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.feature.FeatureQuery;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.dal.swing.DataSwingManager;
import org.gvsig.fmap.dal.swing.impl.jdbc.DefaultJDBCConnectionPanel;
import org.gvsig.fmap.dal.swing.jdbc.JDBCConnectionPanel;
import org.gvsig.tools.exception.BaseException;
import org.gvsig.tools.service.ServiceException;


/**
 * @author fdiaz
 *
 */
public class DefaultDataSwingManager implements
DataSwingManager {

    private FeatureFormDefinitionsProvider featureFormDefinitionsProvider = null;
            
    public JFeatureForm createJFeatureForm(FeatureStore store) throws CreateJFeatureFormException {
        DefaultJFeatureForm form = new DefaultJFeatureForm();
        try {
            if( featureFormDefinitionsProvider!=null ) {
                form.bind(store, this.featureFormDefinitionsProvider.get(store));
            } else {
                form.bind(store);
            }
        } catch (ServiceException e) {
            throw new CreateJFeatureFormException(e);
        } catch (DataException e) {
            throw new CreateJFeatureFormException(e);
        }
        return form;
    }

    public void registerFeatureFormDefinitionsProvider(FeatureFormDefinitionsProvider provider) {
        this.featureFormDefinitionsProvider = provider;
    }

    public FeatureFormDefinitionsProvider getFeatureFormDefinitionsProvider() {
        return this.featureFormDefinitionsProvider;
    }

    public JDBCConnectionPanel createJDBCConnectionPanel() {
        JDBCConnectionPanel x = new DefaultJDBCConnectionPanel();
        return x;
    }



}
