/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */

package org.gvsig.fmap.geom.operation.towkb;

import org.gvsig.fmap.geom.Geometry;

public class WKBMultyLineInLineDefinitionException extends WKBEncodingException {

	/**
	 * Generated serial version UID
	 */
	private static final long serialVersionUID = -4562404266549127771L;

	/**
	 * Key to retrieve this exception's message
	 */
	private static final String MESSAGE_KEY = "wkb_move_in_middle_of_line_exception";
	private static final String FORMAT_STRING =
		"MoveTo segment in middle of a single line";

	/**
	 * Class name of the geometry type. Should never be null in this exception
	 */
	public Geometry geometry = null;


	public WKBMultyLineInLineDefinitionException(Geometry geom) {
		super(FORMAT_STRING, MESSAGE_KEY, serialVersionUID);
		this.geometry = geom;
	}

}
