/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.fmap.mapcontext;

import org.gvsig.tools.exception.BaseException;

/**
 * Parent class for MapContext exceptions.
 * 
 * @author <a href="mailto:cordinyana@gvsig.org">Csar Ordiana</a>
 */
public abstract class MapContextException extends BaseException {

    private static final long serialVersionUID = 8122532768532097211L;

    /**
     * @see BaseException#BaseException(String, String, long)
     */
    protected MapContextException(String message, String key, long code) {
        super(message, key, code);
    }

    /**
     * @see BaseException#BaseException(String, Throwable, String, long)
     */
    protected MapContextException(String message, Throwable cause, String key,
            long code) {
        super(message, cause, key, code);
    }

    public MapContextException(Throwable cause) {
        this(
        		"MapContext related error",
        		cause,
        		"_MapContext_related_error", 
        		serialVersionUID
        );
    }
}
