/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.fmap.mapcontext.persistence;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.cresques.cts.IProjection;
import org.gvsig.fmap.dal.DataQuery;
import org.gvsig.fmap.dal.DataServerExplorer;
import org.gvsig.fmap.dal.DataSet;
import org.gvsig.fmap.dal.DataStoreParameters;
import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
import org.gvsig.fmap.dal.feature.EditableFeature;
import org.gvsig.fmap.dal.feature.EditableFeatureType;
import org.gvsig.fmap.dal.feature.Feature;
import org.gvsig.fmap.dal.feature.FeatureCache;
import org.gvsig.fmap.dal.feature.FeatureIndex;
import org.gvsig.fmap.dal.feature.FeatureIndexes;
import org.gvsig.fmap.dal.feature.FeatureLocks;
import org.gvsig.fmap.dal.feature.FeatureQuery;
import org.gvsig.fmap.dal.feature.FeatureReference;
import org.gvsig.fmap.dal.feature.FeatureSelection;
import org.gvsig.fmap.dal.feature.FeatureSet;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.dal.feature.FeatureStoreTransforms;
import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.fmap.dal.feature.NewFeatureStoreParameters;
import org.gvsig.fmap.dal.feature.exception.NeedEditingModeException;
import org.gvsig.fmap.geom.primitive.Envelope;
import org.gvsig.timesupport.Interval;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.dynobject.DynClass;
import org.gvsig.tools.dynobject.DynObject;
import org.gvsig.tools.dynobject.DynStruct;
import org.gvsig.tools.dynobject.exception.DynFieldNotFoundException;
import org.gvsig.tools.dynobject.exception.DynMethodException;
import org.gvsig.tools.exception.BaseException;
import org.gvsig.tools.observer.Observer;
import org.gvsig.tools.persistence.PersistenceManager;
import org.gvsig.tools.persistence.PersistentState;
import org.gvsig.tools.persistence.exception.PersistenceException;
import org.gvsig.tools.undo.RedoException;
import org.gvsig.tools.undo.UndoException;
import org.gvsig.tools.visitor.Visitor;

public class DummyDBFeatureStore implements FeatureStore {

	private String name = "[empty]";

	public DummyDBFeatureStore() {

	}

	public DummyDBFeatureStore(String id) {
		name = "[DATABASE FEATURE STORE - " + id + "]";
	}

	public boolean allowWrite() {
		// TODO Auto-generated method stub
		return false;
	}

	public void beginEditingGroup(String description)
			throws NeedEditingModeException {
		// TODO Auto-generated method stub

	}

	public boolean canWriteGeometry(int gvSIGgeometryType) throws DataException {
		// TODO Auto-generated method stub
		return false;
	}

	public void cancelEditing() throws DataException {
		// TODO Auto-generated method stub

	}

	public FeatureQuery createFeatureQuery() {
		// TODO Auto-generated method stub
		return null;
	}

	public FeatureSelection createFeatureSelection() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public FeatureIndex createIndex(FeatureType featureType,
			String attributeName, String indexName) throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public FeatureIndex createIndex(FeatureType featureType,
			String attributeName, String indexName, Observer observer)
			throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public EditableFeature createNewFeature() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public EditableFeature createNewFeature(FeatureType type,
			Feature defaultValues) throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public EditableFeature createNewFeature(FeatureType type,
			boolean defaultValues) throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public EditableFeature createNewFeature(boolean defaultValues)
			throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public void delete(Feature feature) throws DataException {
		// TODO Auto-generated method stub

	}

	public void edit() throws DataException {
		// TODO Auto-generated method stub

	}

	public void edit(int mode) throws DataException {
		// TODO Auto-generated method stub

	}

	public void endEditingGroup() throws NeedEditingModeException {
		// TODO Auto-generated method stub

	}

	public void export(DataServerExplorer explorer,
			String providerName,
			NewFeatureStoreParameters params) throws DataException {
		// TODO Auto-generated method stub

	}

	public void finishEditing() throws DataException {
		// TODO Auto-generated method stub

	}

	public FeatureType getDefaultFeatureType() throws DataException {
		return new DummyFileFeatureStore.DummyFeatureType();
	}

	public Envelope getEnvelope() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public Feature getFeatureByReference(FeatureReference reference)
			throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public Feature getFeatureByReference(FeatureReference reference,
			FeatureType featureType) throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public long getFeatureCount() throws DataException {
		// TODO Auto-generated method stub
		return 0;
	}

	public FeatureSelection getFeatureSelection() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public FeatureSet getFeatureSet() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public FeatureSet getFeatureSet(FeatureQuery featureQuery)
			throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public void getFeatureSet(FeatureQuery featureQuery, Observer observer)
			throws DataException {
		// TODO Auto-generated method stub

	}

	public void getFeatureSet(Observer observer) throws DataException {
		// TODO Auto-generated method stub

	}

	public FeatureType getFeatureType(String featureTypeId)
			throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public List getFeatureTypes() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public FeatureIndexes getIndexes() {
		// TODO Auto-generated method stub
		return null;
	}

	public FeatureLocks getLocks() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public DataStoreParameters getParameters() {
		// TODO Auto-generated method stub
		return null;
	}

	public IProjection getSRSDefaultGeometry() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public FeatureStoreTransforms getTransforms() {
		// TODO Auto-generated method stub
		return null;
	}

	public void insert(EditableFeature feature) throws DataException {
		// TODO Auto-generated method stub

	}

	public boolean isAppendModeSupported() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isAppending() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isEditing() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isLocksSupported() {
		// TODO Auto-generated method stub
		return false;
	}

	public void setSelection(FeatureSet selection) throws DataException {
		// TODO Auto-generated method stub

	}

	public void update(EditableFeatureType featureType) throws DataException {
		// TODO Auto-generated method stub

	}

	public void update(EditableFeature feature) throws DataException {
		// TODO Auto-generated method stub

	}

	public void validateFeatures(int mode) throws DataException {
		// TODO Auto-generated method stub

	}

	public DataQuery createQuery() {
		// TODO Auto-generated method stub
		return null;
	}

	public DataSet createSelection() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public void dispose() {
		// TODO Auto-generated method stub

	}

	public Iterator getChildren() {
		// TODO Auto-generated method stub
		return null;
	}

	public DataSet getDataSet() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public DataSet getDataSet(DataQuery dataQuery) throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public void getDataSet(Observer observer) throws DataException {
		// TODO Auto-generated method stub

	}

	public void getDataSet(DataQuery dataQuery, Observer observer)
			throws DataException {
		// TODO Auto-generated method stub

	}

	public DataServerExplorer getExplorer() throws DataException,
			ValidateDataParametersException {
		// TODO Auto-generated method stub
		return null;
	}

	public String getName() {
		// TODO Auto-generated method stub
		return name;
	}

	public DataSet getSelection() throws DataException {
		// TODO Auto-generated method stub
		return null;
	}

	public void refresh() throws DataException {
		// TODO Auto-generated method stub

	}

	public void setSelection(DataSet selection) throws DataException {
		// TODO Auto-generated method stub

	}

	public void beginComplexNotification() {
		// TODO Auto-generated method stub

	}

	public void disableNotifications() {
		// TODO Auto-generated method stub

	}

	public void enableNotifications() {
		// TODO Auto-generated method stub

	}

	public void endComplexNotification() {
		// TODO Auto-generated method stub

	}

	public void addObserver(Observer o) {
		// TODO Auto-generated method stub

	}

	public void deleteObserver(Observer o) {
		// TODO Auto-generated method stub

	}

	public void deleteObservers() {
		// TODO Auto-generated method stub

	}

	public void loadFromState(PersistentState state) throws PersistenceException {
		name = state.getString("name");
	}

	public void saveToState(PersistentState state) throws PersistenceException {
		state.set("name", name);
	}

	public Set getMetadataChildren() {
		// TODO Auto-generated method stub
		return null;
	}

	public Object getMetadataID() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getMetadataName() {
		// TODO Auto-generated method stub
		return null;
	}

	public void delegate(DynObject dynObject) {
		// TODO Auto-generated method stub

	}

	public DynClass getDynClass() {
		// TODO Auto-generated method stub
		return null;
	}

	public Object getDynValue(String name) throws DynFieldNotFoundException {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean hasDynValue(String name) {
		// TODO Auto-generated method stub
		return false;
	}

	public void implement(DynClass dynClass) {
		// TODO Auto-generated method stub

	}

	public Object invokeDynMethod(String name, DynObject context)
			throws DynMethodException {
		// TODO Auto-generated method stub
		return null;
	}

	public Object invokeDynMethod(int code, DynObject context)
			throws DynMethodException {
		// TODO Auto-generated method stub
		return null;
	}

	public void setDynValue(String name, Object value)
			throws DynFieldNotFoundException {
		// TODO Auto-generated method stub

	}

	public boolean canRedo() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean canUndo() {
		// TODO Auto-generated method stub
		return false;
	}

	public List getRedoInfos() {
		// TODO Auto-generated method stub
		return null;
	}

	public List getUndoInfos() {
		// TODO Auto-generated method stub
		return null;
	}

	public void redo() throws RedoException {
		// TODO Auto-generated method stub

	}

	public void redo(int num) throws RedoException {
		// TODO Auto-generated method stub

	}

	public void undo() throws UndoException {
		// TODO Auto-generated method stub

	}

	public void undo(int num) throws UndoException {
		// TODO Auto-generated method stub

	}


	public static void registerPersistent() {
		PersistenceManager manager = ToolsLocator.getPersistenceManager();
		DynStruct definition = manager.addDefinition(
				DummyDBFeatureStore.class,
				"DummyDBFeatureStore",
				"DummyDBFeatureStore Persistence definition",
				null,
				null
		);
		definition.addDynFieldString("name");
	}

	public void accept(Visitor visitor) throws BaseException {
		// TODO Auto-generated method stub

	}

	public void accept(Visitor visitor, DataQuery dataQuery)
			throws BaseException {
		// TODO Auto-generated method stub

	}

	public void createCache(String name, DynObject parameters)
			throws DataException {
		// TODO Auto-generated method stub

	}

	public FeatureCache getCache() {
		// TODO Auto-generated method stub
		return null;
	}

	public void clear() {
		// Nothing to do
	}

	public String getProviderName() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getFullName() {
		// TODO Auto-generated method stub
		return null;
	}

    public boolean isKnownEnvelope() {
        // TODO Auto-generated method stub
        return false;
    }

    public boolean hasRetrievedFeaturesLimit() {
        // TODO Auto-generated method stub
        return false;
    }

    public int getRetrievedFeaturesLimit() {
        // TODO Auto-generated method stub
        return 0;
    }

    public Interval getInterval() {
        // TODO Auto-generated method stub
        return null;
    }

    public Collection getTimes() {
        // TODO Auto-generated method stub
        return null;
    }

    public Collection getTimes(Interval interval) {
        // TODO Auto-generated method stub
        return null;
    }

    public FeatureIndex createIndex(String indexTypeName,
        FeatureType featureType, String attributeName, String indexName)
        throws DataException {
        // TODO Auto-generated method stub
        return null;
    }

    public FeatureIndex createIndex(String indexTypeName,
        FeatureType featureType, String attributeName, String indexName,
        Observer observer) throws DataException {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#clone()
     */
    public Object clone() throws CloneNotSupportedException {
        // TODO Auto-generated method stub
        return super.clone();
    }

    /* (non-Javadoc)
     * @see org.gvsig.fmap.dal.feature.FeatureStore#commitChanges()
     */
    public void commitChanges() throws DataException {
        // TODO Auto-generated method stub

    }

    /* (non-Javadoc)
     * @see org.gvsig.fmap.dal.feature.FeatureStore#canCommitChanges()
     */
    public boolean canCommitChanges() throws DataException {
        // TODO Auto-generated method stub
        return false;
    }

    public Feature getFeature(DynObject dynobject) {
        // TODO Auto-generated method stub
        return null;
    }
}