/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.remoteclient.exceptions;

/**
 * Excepcin provocada por el WCS.
 *
 * @author Jaume Dominguez Faus - jaume.dominguez@iver.es
 */
public class WCSException extends Exception 
{	
	private String wcs_message = null;
	
	/**
	 *
	 */
	public WCSException() {
		super();
	}

	/**
	 * Creates a new WCS Exception
	 *
	 * @param message
	 */
	public WCSException(String message) {
		super(message);
	}

	/**
	 * Creates a new WCS Exception
	 *
	 * @param message
	 * @param cause
	 */
	public WCSException(String message, Throwable cause) {
		super(message, cause);
	}

	/**
	 * Creates a new WCSException
	 *
	 * @param cause
	 */
	public WCSException(Throwable cause) {
		super(cause);
	}
	
	public String getWCSMessage()
	{
		if (wcs_message == null)
			return "";
		else
			return wcs_message;
	}
	
	public void setWCSMessage(String mes)
	{
		wcs_message = mes;
	}
}


