/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.remoteclient.wcs;

import java.util.HashMap;
import java.util.Vector;

import org.gvsig.remoteclient.ogc.OGCClientOperation;
import org.gvsig.remoteclient.ogc.OGCServiceInformation;

/**
 * @author <a href="mailto:jpiera@gvsig.org">Jorge Piera</a>
 */
public class WCSServiceInformation extends OGCServiceInformation {
	 public String online_resource = null;
     public String version;
     public String name;
     public String scope;
     public String title;
     public String abstr;
     public String keywords;
     public String fees;
     public String operationsInfo;
     public String personname;
     public String organization;
     public String function;
     public String addresstype;
     public String address;
     public String place;
     public String province;
     public String postcode;
     public String country;
     public String phone;
     public String fax;
     public String email;
     public Vector formats;
     public HashMap operations; // operations that WCS supports

     public WCSServiceInformation()
     {
         version = new String();
         name = new String();
         scope = new String();
         title = new String();
         abstr = new String();
         keywords = new String();
         fees = new String();
         operationsInfo = new String();
         personname = new String();
         organization = new String();
         function = new String();
         addresstype = new String();
         address = new String();
         place = new String();
         province = new String();
         postcode = new String();
         country = new String();
         phone = new String();
         fax = new String();
         email = new String();
         operations = new HashMap();
     }

	public OGCClientOperation createOperation(String name) {
		return new WCSOperation(name); 
	}

	public OGCClientOperation createOperation(String name, String onlineResource) {
		return new WCSOperation(name, onlineResource);
	}

  
}

