/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.andami.installer.packagebuilder.options;

import java.awt.BorderLayout;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import org.gvsig.andami.installer.packagebuilder.PackageWizard;
import org.gvsig.gui.beans.wizard.panel.NotContinueWizardException;
import org.gvsig.gui.beans.wizard.panel.OptionPanel;
import org.gvsig.i18n.Messages;
import org.jdesktop.layout.GroupLayout;
import org.jdesktop.layout.LayoutStyle;

/**
 *
 * @author usuario
 */
public class SelectFolderToPackagingOption extends JPanel  implements OptionPanel {

    private PackageWizard wizard = null;
    
    /**
     * Creates new form SelectFolderToPackagingOption
     */
    public SelectFolderToPackagingOption(PackageWizard wizard, String message) {
        this.wizard = wizard;
        initComponents();
        if( message == null ) {
            this.jLabel1.setText(Messages.getText(this.jLabel1.getText()));
        } else {
            this.jLabel1.setText(message);
        }
    }

        public JPanel getJPanel() {
        return this;
    }

    public void lastPanel() {

    }

    public void nextPanel() throws NotContinueWizardException {
        File file = jFileChooser1.getSelectedFile();
        if( file!=null ) {
            wizard.setFolderToPackaging(file);
        }
    }

    public void updatePanel() {

    }

    public String getPanelTitle() {
        return Messages.getText("_select_translations_folder");
    }

    public void setCurrentFolder(File folder) {
        this.jFileChooser1.setCurrentDirectory(folder);
    }
    
    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new JLabel();
        jFileChooser1 = new JFileChooser();

        setLayout(new BorderLayout());

        jLabel1.setText("_Seleccione_la_carpeta_donde_estan_los _contenidos_a_empaquetar");
        add(jLabel1, BorderLayout.PAGE_START);

        jFileChooser1.setControlButtonsAreShown(false);
        jFileChooser1.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        add(jFileChooser1, BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected JFileChooser jFileChooser1;
    protected JLabel jLabel1;
    // End of variables declaration//GEN-END:variables
}
