/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.andami.messages;

import java.util.Locale;
import java.util.ResourceBundle;


/**
 * Clase que accede a los recursos para la i18n
 */
public class Messages {
    /** DOCUMENT ME! */
    private static final String BUNDLE_NAME = "org.gvsig.andami.text";

    /** DOCUMENT ME! */
    private static ResourceBundle RESOURCE_BUNDLE = null;

    /**
     * Inicializa la clase con el locale adecuado
     *
     * @param loc Locale de la aplicacin
     */
    public static void init(Locale loc) {
    	return;
    }

    /**
     * @param strLocale. Ejemplo: va para valenciano
     * Se trata de permitir coexistir el valenciano con el cataln.
     * El mtodo buscar un fichero properties llamado "text_va.properties"
     * para usarlo con RESOURCE_BUNDLE de donde sacar los mensajes
     * traducidos.
     */
    public static void init(String strLocale) {
    	return;
    }
    
    
    /**
     * Obtiene el valor del recurso con clave 'key'
     *
     * @param key clave del recurso que se quiere obtener
     *
     * @return recurso que se quiere obtener o !key! en caso de no encontrarlo.
     *         En dicho caso no se notifica al framework ya que  estos son los
     *         mensajes propios de la aplicacin y deben de estar todos
     */
    public static String getString(String key) {
        return org.gvsig.i18n.Messages.getText(key, "org.gvsig.andami.messages.Messages");
    }
    
    public static String get(String key) {
        return org.gvsig.i18n.Messages.getText(key, "org.gvsig.andami.messages.Messages");
    }
}
