{
PATH="$PWD/tools;$PATH"
ROOT="$PWD"

####################
# Identify OS and Architecture  #
####################

UNAME=$(uname -a)
if echo "$UNAME" | grep -i "win" >/dev/null; then
	OS="win"
	ARG_D32=""
        CPSEP=";"
else
	if echo "$UNAME" | grep -i "lin" >/dev/null ; then
		OS="lin"
		# Only linux support -d32 arg
		ARG_D32="-d32"
                CPSEP=":"
	else
		OS="unknown"
		ARG_D32=""
                CPSEP=":"
	fi
fi
if echo "$UNAME" | egrep -i "(x86_64)|(amd64)" >/dev/null ; then
	ARCH="x86_64"
else
	ARCH="x86"
fi

echo -e "\nCurrent directory: $ROOT"
uname -a
echo -e "\nDump file list and sizes\n"
du -k "$ROOT"
echo -e "\nCalculating md5sum of dlls and exes...\n"
cd "$ROOT"
for f in $(find . -name "*.exe")
do
	md5sum $f
done
for f in $(find . -name "*.dll")
do
	md5sum $f
done
echo -e "\nCheck DLL dependencies...\n"
for f in $(find . -name "*.dll")
do
	cygcheck.exe "$f"
	echo ""
done
for f in $(find . -name "*.so*")
do
	ldd "$f"
	echo ""
done

}