/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.exportto;

import org.gvsig.fmap.dal.feature.Feature;
import org.gvsig.tools.service.ServiceException;

/**
 * Exception thrown when there is an error getting a Exportto message.
 * 
 * @author gvSIG team
 * @version $Id$
 */
public class ExporttoServiceException extends ServiceException {

    private static final long serialVersionUID = -7423501876634702709L;

    private static final String MESSAGE =
        "An error has been produced exporting a store";

    private static final String KEY = "_ExporttoServiceException";
    protected Feature feature = null;

    /**
     * Creates a new {@link ExporttoServiceException}.
     * 
     * @param cause
     *            the original cause
     */
    public ExporttoServiceException(Throwable cause) {
        super(MESSAGE, cause, KEY, serialVersionUID);
    }

    protected ExporttoServiceException(String message, Throwable cause, String key, long code) {
        super(message, cause, key, code);
    }
    
    public ExporttoServiceException(Throwable cause, Feature feature) {
        super(MESSAGE, cause, KEY, serialVersionUID);
        this.feature = feature;
    }

    public ExporttoServiceException(String message, Throwable cause) {
        super(message, cause, KEY, serialVersionUID);
    }
    
    public Feature getFeature() {
        return this.feature;
    }
}
