/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
/* gvSIG. Geographic Information System of the Valencian Government
*
* Copyright (C) 2007-2008 Infrastructures and Transports Department
* of the Valencian Government (CIT)
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
* MA  02110-1301, USA.
* 
*/

/*
* AUTHORS (In addition to CIT):
* 2009 {DiSiD Technologies}  {{Task}}
*/
package org.gvsig.symbology.fmap.mapcontext.rendering.legend.impl;

import org.gvsig.fmap.dal.feature.Feature;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.mapcontext.rendering.legend.events.FeatureDrawnNotification;

/**
 * @author <a href="mailto:cordinyana@gvsig.org">Csar Ordiana</a>
 */
public class DefaultFeatureDrawnNotification implements FeatureDrawnNotification {
	
	private Feature feature;
	private Geometry drawnGeometry;

	/**
	 * Creates a new FeatureDrawnNotification.
	 */
	public DefaultFeatureDrawnNotification() {
		// Nothing to do
	}

	/**
	 * Creates a new FeatureDrawnNotification.
	 * @param feature the {@link Feature} being drawn
	 * @param drawnGeometry the {@link Geometry} to be finally drawn, as it may
	 * have been reprojected
	 */
	public DefaultFeatureDrawnNotification(Feature feature, Geometry drawnGeometry) {
		this.setFeature(feature);
		this.setDrawnGeometry(drawnGeometry);
	}

	public Feature getFeature() {
		return feature;
	}

	public void setFeature(Feature feature) {
		this.feature = feature;
	}

	/**
	 * @return the {@link Geometry} to be finally drawn, as it may
	 * have been reprojected
	 */
	public Geometry getDrawnGeometry() {
		return drawnGeometry;
	}

	public void setDrawnGeometry(Geometry drawnGeometry) {
		this.drawnGeometry = drawnGeometry;
	}
}