/* gvSIG. Geographic Information System of the Valencian Government
 *
 * Copyright (C) 2007-2008 Infrastructures and Transports Department
 * of the Valencian Government (CIT)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 */
package org.gvsig.timesupport.impl;

import org.gvsig.timesupport.Chronology;



/**
 * @author gvSIG Team
 * @version $Id$
 *
 */
public class DefaultChronology implements Chronology {
    private org.joda.time.Chronology jodaChronology = null;
    private Chronology withUTC= null;
    private int type = 0;
    
    DefaultChronology(int type, org.joda.time.Chronology dateTimeFieldType) {
        super();    
        this.type = type;
        this.jodaChronology = dateTimeFieldType;        
    }
    
    org.joda.time.Chronology getJodaType() {      
        return jodaChronology;
    } 

    public int getType() {
        return type;
    }

    public Chronology withUTC() {       
        if (withUTC == null){
            withUTC = new DefaultChronology(type, jodaChronology.withUTC());
        }
        return withUTC;
    }    
}
