/* gvSIG. Geographic Information System of the Valencian Government
*
* Copyright (C) 2007-2008 Infrastructures and Transports Department
* of the Valencian Government (CIT)
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
* MA  02110-1301, USA.
* 
*/

/*
* AUTHORS (In addition to CIT):
* 2010 {Prodevelop}   {Task}
*/
package org.gvsig.timesupport.swing.api;

import org.gvsig.timesupport.Interval;
import org.gvsig.timesupport.animation.TimeAnimationDataModel;
import org.gvsig.timesupport.swing.api.panel.AnimationBarPanel;
import org.gvsig.timesupport.swing.api.panel.AnimationPreferencesPanel;
import org.gvsig.timesupport.swing.api.panel.TimeSelectorPanel;

/**
 * <p>This manager is used to instantiate a GetObservation window </p>
 * @author <a href="mailto:Pablo.Viciano@uji.es">Pablo Viciano Negre</a>
 */
public interface TimeSupportSwingManager {

	public TimeSelectorPanel createTimeSelectorPanel(Interval interval) throws TimeSupportSwingException;
	
	public AnimationBarPanel createAnimationBarPanel(TimeAnimationDataModel dataModel);
	
	public AnimationPreferencesPanel createAnimationPreferencesPanel(TimeAnimationDataModel dataModel);
}
