/* gvSIG. Geographic Information System of the Valencian Government
 *
 * Copyright (C) 2007-2008 Infrastructures and Transports Department
 * of the Valencian Government (CIT)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 */
package org.gvsig.timesupport.swing.impl;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;

import org.gvsig.timesupport.RelativeInstant;
import org.gvsig.timesupport.TimeSupportLocator;
import org.gvsig.timesupport.TimeSupportManager;
import org.gvsig.timesupport.swing.impl.panel.TimePanel;
import org.gvsig.tools.library.impl.DefaultLibrariesInitializer;

/**
 * Test for the panel TimeSupportManager
 * 
 * @author <a href="mailto:nachobrodin@gmail.com">Nacho Brodin</a>
 * 
 */
public class TestTimePanel implements ActionListener {
		private int                          w        = 500;
		private int                          h        = 250;
		private JFrame                       frame    = new JFrame();
		private TimePanel                    desc     = null;

		public TestTimePanel() {
			new DefaultLibrariesInitializer().fullInitialize();
			desc = new TimePanel();
			TimeSupportManager timeSupportManager = TimeSupportLocator.getManager();
			RelativeInstant startInstant = timeSupportManager.createRelativeInstant(2000, 1, 1, 12, 00, 00, 00);
			RelativeInstant endInstant = timeSupportManager.createRelativeInstant(2010, 1, 12, 13, 30, 00, 00);
			desc.initialize(startInstant, endInstant);
			frame.getContentPane().add(desc);
			frame.setSize(w, h);
			frame.setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
			frame.setVisible(true);
		}

		public static void main(String[] args) {
			new TestTimePanel();
		}

		private boolean doubleSize = false;
		public void actionPerformed(ActionEvent e) {
			if(!doubleSize)
				frame.setSize(w * 2, h);
			else
				frame.setSize(w, h);
			doubleSize = !doubleSize;
		}

//		public void stateChanged(ChangeEvent e) {
//			if(e.getSource() == desc.getTabs()) {
//				if(desc.getTabs().getSelectedIndex() == 2) {
//					frame.setSize(w, 600);
//				} else {
//					frame.setSize(w, h);
//				}
//			}
//		}
	}
