/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */

package org.gvsig.app.extension.develtools;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTextPane;
import javax.swing.border.TitledBorder;
import org.jdesktop.layout.GroupLayout;


public class EditingListenerPanelLayout extends javax.swing.JPanel {

    /**
     * Creates new form EditingListenerPanelLayout
     */
    public EditingListenerPanelLayout() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        GridBagConstraints gridBagConstraints;

        lblEditNotifications = new JLabel();
        btnClose = new JButton();
        btnClear = new JButton();
        jSeparator1 = new JSeparator();
        jSeparator2 = new JSeparator();
        chkAskToAceptNotification = new JCheckBox();
        jScrollPane2 = new JScrollPane();
        txtNotifications = new JTextPane();
        chkShowFeatureInForm = new JCheckBox();
        chkSkipFeatureValidation = new JCheckBox();

        setBorder(null);
        GridBagLayout layout = new GridBagLayout();
        layout.columnWidths = new int[] {0, 4, 0, 4, 0, 4, 0, 4, 0};
        layout.rowHeights = new int[] {0, 4, 0, 4, 0, 4, 0, 4, 0, 4, 0, 4, 0, 4, 0, 4, 0};
        setLayout(layout);

        lblEditNotifications.setText("Editing notifications");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(lblEditNotifications, gridBagConstraints);

        btnClose.setText("Close");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = GridBagConstraints.LINE_END;
        add(btnClose, gridBagConstraints);

        btnClear.setText("Clear");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = GridBagConstraints.LINE_END;
        add(btnClear, gridBagConstraints);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(jSeparator1, gridBagConstraints);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(jSeparator2, gridBagConstraints);

        chkAskToAceptNotification.setText("Ask to acept or cancel notification");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        add(chkAskToAceptNotification, gridBagConstraints);

        txtNotifications.setContentType("text/html"); // NOI18N
        jScrollPane2.setViewportView(txtNotifications);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jScrollPane2, gridBagConstraints);

        chkShowFeatureInForm.setText("Show feature in form"); // NOI18N
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        add(chkShowFeatureInForm, gridBagConstraints);

        chkSkipFeatureValidation.setText("Skip feature validation");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = GridBagConstraints.LINE_START;
        add(chkSkipFeatureValidation, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected JButton btnClear;
    protected JButton btnClose;
    protected JCheckBox chkAskToAceptNotification;
    protected JCheckBox chkShowFeatureInForm;
    protected JCheckBox chkSkipFeatureValidation;
    protected JScrollPane jScrollPane2;
    protected JSeparator jSeparator1;
    protected JSeparator jSeparator2;
    protected JLabel lblEditNotifications;
    protected JTextPane txtNotifications;
    // End of variables declaration//GEN-END:variables
}
