/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.app.project.documents.gui;

import org.gvsig.andami.ui.mdiManager.IWindow;
import org.gvsig.andami.ui.mdiManager.WindowInfo;
import org.gvsig.utils.swing.wizard.Wizard;

/**
 * Vista de andami que contiene un asistente
 * 
 * @author Fernando Gonzlez Corts
 */
public class AndamiWizard extends Wizard implements IWindow {

    private static final long serialVersionUID = -4320079648891816068L;

    /**
     * @param backText
     * @param nextText
     * @param finishText
     * @param cancelText
     */
    public AndamiWizard(String backText, String nextText, String finishText,
        String cancelText) {
        super(backText, nextText, finishText, cancelText);
    }

    /**
     * @see org.gvsig.andami.ui.mdiManager.IWindow#getWindowInfo()
     */
    public WindowInfo getWindowInfo() {
        return new WindowInfo(WindowInfo.ICONIFIABLE | WindowInfo.MAXIMIZABLE
            | WindowInfo.RESIZABLE);
    }

    public Object getWindowProfile() {
        // TODO Auto-generated method stub
        return WindowInfo.PROPERTIES_PROFILE;
    }
}
