/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.app.project.documents.view.legend.gui;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * Utility class to deal with legend files (sld, gvsleg, etc)
 */
public class LegendFileFilter extends FileFilter {

    private String fileExt = "";
    private String description = "";
    
    public LegendFileFilter(String ext, String desc) {
        fileExt = ext.toLowerCase();
        description = desc;
    }
    
    public LegendFileFilter(String ext) {
        fileExt = ext.toLowerCase();
        description = ext.toUpperCase() + " format for legends (*."
            + ext.toLowerCase() + ")";
    }
    
    public String getFileExtension() {
        return fileExt;
    }
    
    public boolean accept(File pathname) {
        if (pathname.isDirectory()) {
            return true;
        } else {
            return pathname.getAbsolutePath().toLowerCase().endsWith("." + fileExt);
        }
    }
    

    public String getDescription() {
        return description;
    }
    

}
