/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gvsig.coreplugin.preferences.general;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import org.gvsig.andami.PluginServices;
import org.gvsig.andami.PluginsLocator;
import org.gvsig.andami.PluginsManager;
import org.gvsig.andami.preferences.AbstractPreferencePage;
import org.gvsig.andami.preferences.StoreException;
import org.gvsig.coreplugin.PreferencesExtension;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.dynobject.DynObject;
import org.gvsig.tools.i18n.I18nManager;

/**
 *
 * @author usuario
 */
public class NotificationsPage extends AbstractPreferencePage {

    /**
     * Creates new form NotificationsPage
     */
    public NotificationsPage() {
        initComponents();
        translate();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        GridBagConstraints gridBagConstraints;

        jLabel1 = new JLabel();
        jchkShowInConsole = new JCheckBox();
        jchkShowInStatusbar = new JCheckBox();
        jLabel2 = new JLabel();

        GridBagLayout layout = new GridBagLayout();
        layout.columnWidths = new int[] {0, 5, 0};
        layout.rowHeights = new int[] {0, 5, 0, 5, 0, 5, 0};
        setLayout(layout);

        jLabel1.setText("Select the notification mode");
        jLabel1.setHorizontalTextPosition(SwingConstants.LEFT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
        add(jLabel1, gridBagConstraints);

        jchkShowInConsole.setText("Show notificacion in console window");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
        add(jchkShowInConsole, gridBagConstraints);

        jchkShowInStatusbar.setText("Show notifications in statusbar");
        jchkShowInStatusbar.setHorizontalAlignment(SwingConstants.LEFT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
        add(jchkShowInStatusbar, gridBagConstraints);

        jLabel2.setText("The changes take effect in next execution of the application");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        add(jLabel2, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected JLabel jLabel1;
    protected JLabel jLabel2;
    protected JCheckBox jchkShowInConsole;
    protected JCheckBox jchkShowInStatusbar;
    // End of variables declaration//GEN-END:variables

    private void translate() {
        I18nManager i18nManager = ToolsLocator.getI18nManager();
        
        jLabel1.setText(i18nManager.getTranslation("Select_the_notification_mode"));
        jchkShowInConsole.setText(i18nManager.getTranslation("Show_notifications_in_the_console_window"));
        jchkShowInStatusbar.setText(i18nManager.getTranslation("Show_notifications_in_the_statusbar"));
        jLabel2.setText(i18nManager.getTranslation("Los_cambios_efectuados_sobre_estos_valores_se_aplicaran_al_reiniciar_la_aplicacion"));
    }
    
    @Override
    public void storeValues() throws StoreException {
        PluginsManager pluginsManager = PluginsLocator.getManager();
        PluginServices plugin = pluginsManager.getPlugin(PreferencesExtension.class);
        
        DynObject pluginProperties = plugin.getPluginProperties();
        pluginProperties.setDynValue(
                "showNotificationsInConsole", 
                new Boolean(jchkShowInConsole.isSelected())
        );
        pluginProperties.setDynValue(
                "showNotificationsInStatusbar", 
                new Boolean(jchkShowInStatusbar.isSelected())
        );
        plugin.savePluginProperties();
    }

    @Override
    public void setChangesApplied() {

    }

    public String getID() {
        return this.getClass().getName();
    }

    public String getTitle() {
        I18nManager i18nManager = ToolsLocator.getI18nManager();
        return i18nManager.getTranslation("notifications_mode");
    }

    public JPanel getPanel() {
        return this;
    }

    public void initializeValues() {
        PluginsManager pluginsManager = PluginsLocator.getManager();
        PluginServices plugin = pluginsManager.getPlugin(PreferencesExtension.class);
        
        DynObject pluginProperties = plugin.getPluginProperties();
        jchkShowInStatusbar.setSelected(
                ((Boolean)pluginProperties.getDynValue("showNotificationsInStatusbar")).booleanValue());
        jchkShowInConsole.setSelected(
                ((Boolean)pluginProperties.getDynValue("showNotificationsInConsole")).booleanValue());
    }

    public void initializeDefaults() {
        jchkShowInStatusbar.setSelected(true);
        jchkShowInConsole.setSelected(false);
    }

    public ImageIcon getIcon() {
        return null;
    }

    public boolean isValueChanged() {
        return true;
    }
}
