/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.geodb.vectorialdb;

import org.gvsig.fmap.dal.DALLocator;
import org.gvsig.fmap.dal.DataManager;
import org.gvsig.fmap.dal.exception.InitializeException;
import org.gvsig.fmap.dal.exception.ProviderNotRegisteredException;
import org.gvsig.fmap.dal.resource.db.DBParameters;


/**
 * @author Fernando Gonzlez Corts
 */
public class ConnectionSettings {
    private String host;
    private String port;
    private String db;
    private String schema;
    private String driver;
    private String user;
    private String name;
    private String passw;

    public String getDb() {
        return db;
    }
    public void setDb(String db) {
        this.db = db;
    }
    public String getDriver() {
        return driver;
    }
    public void setDriver(String driver) {
        this.driver = driver;
    }
    public String getHost() {
        return host;
    }
    public void setHost(String host) {
        this.host = host;
    }
    public String getPort() {
        return port;
    }
    public void setPort(String port) {
        this.port = port;
    }
    public String getUser() {
        return user;
    }
    public void setUser(String user) {
        this.user = user;
    }
    public void setName(String name) {
        this.name = name;
    }
    public String getName() {
        return name;
    }

    public String toString(){
        return host+","+port+","+db+","+driver+","+user+","+name;
    }

    public void setFromString(String str) {
        String[] values = str.split(",");
        host = values[0];
        port = values[1];
        db = values[2];
        driver = values[3];
        user = values[4];
        name = values[5];
        if (values.length == 7) {
			passw = values[6];
		}
    }
    public String getPassw() {
        return passw;
    }
    public void setPassw(String passw) {
        this.passw = passw;
    }
    public String getConnectionString(){
    	DataManager dm=DALLocator.getDataManager();
    	try {
			DBParameters dsp=(DBParameters)dm.createStoreParameters(getDriver());
		} catch (InitializeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ProviderNotRegisteredException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

        String connectionString = "";//vecDriver.getConnectionStringBeginning() + "//" + getHost();

        connectionString += (":" + getPort());

        connectionString += ("/" + getDb());

        return connectionString;
    }
	public String getSchema() {
		return schema;
	}
	public void setSchema(String schema) {
		this.schema = schema;
	}
}
