/**
 * gvSIG. Desktop Geographic Information System.
 *
 * Copyright (C) 2007-2013 gvSIG Association.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * For any additional information, do not hesitate to contact us
 * at info AT gvsig.com, or visit our website www.gvsig.com.
 */
package org.gvsig.app.project.documents.view.toolListeners.snapping.gui;

import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.gvsig.andami.PluginServices;
import org.gvsig.andami.ui.mdiManager.IWindow;
import org.gvsig.andami.ui.mdiManager.WindowInfo;
import org.gvsig.fmap.mapcontrol.tools.snapping.snappers.ISnapper;
import org.gvsig.gui.beans.AcceptCancelPanel;


public class DefaultConfigurePanel extends JPanel implements IWindow {
	private ISnapper snapper;
	private JLabel lblColor = null;
	private JButton bColor = null;
	private WindowInfo wi=null;
	private AcceptCancelPanel acceptCancelPanel;
	/**
	 * This is the default constructor
	 */
	public DefaultConfigurePanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		lblColor = new JLabel();
		lblColor.setText("color");
		this.setSize(269, 91);
		this.add(lblColor, null);
		this.add(getBColor(), null);
		this.add(getPAcceptCancel(),null);
	}
	public void setSnapper(ISnapper snapper) {
		this.snapper=snapper;
		//((AbstractSnapper)this.snapper).setColor(Color.blue);
	}

	/**
	 * This method initializes bColor
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getBColor() {
		if (bColor == null) {
			bColor = new JButton();
			bColor.setText("...");
		}
		return bColor;
	}

	protected AcceptCancelPanel getPAcceptCancel() {
		if (acceptCancelPanel==null) {
			ActionListener okAction = new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					if (PluginServices.getMainFrame() == null) {
                        ((JDialog) (getParent().getParent().getParent()
                                .getParent())).dispose();
                    } else {
                        PluginServices.getMDIManager().closeWindow(DefaultConfigurePanel.this);
                    }
				}
			};
			ActionListener cancelAction = new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
                    if (PluginServices.getMainFrame() != null) {
                        PluginServices.getMDIManager().closeWindow(DefaultConfigurePanel.this);
                    } else {
                        ((JDialog) (getParent().getParent().getParent()
                                        .getParent())).dispose();
                    }
				}
			};
			acceptCancelPanel=new AcceptCancelPanel(okAction,cancelAction);

		}
		return acceptCancelPanel;
	}

	public WindowInfo getWindowInfo() {
		if (wi==null) {
			wi=new WindowInfo(WindowInfo.MODALDIALOG|WindowInfo.RESIZABLE);
			wi.setWidth(this.getWidth());
			wi.setHeight(this.getHeight());
			wi.setTitle(PluginServices.getText(this,"propiedades"));
		}
		return wi;
	}

	public Object getWindowProfile() {
		return WindowInfo.DIALOG_PROFILE;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
